library Graph;

{ Important note about DLL memory management: ShareMem must be the
  first unit in your library's USES clause AND your project's (select
  Project-View Source) USES clause if your DLL exports any procedures or
  functions that pass strings as parameters or function results. This
  applies to all strings passed to and from your DLL--even those that
  are nested in records and classes. ShareMem is the interface unit to
  the BORLNDMM.DLL shared memory manager, which must be deployed along
  with your DLL. To avoid using BORLNDMM.DLL, pass string information
  using PChar or ShortString parameters. }

uses
  ShareMem,
  Windows,
  SysUtils,
  Classes,
  Forms,
  SharedTypes in '..\SharedTypes.pas',
  GraphMain in 'GraphMain.pas' {fmGraphMain};

var
  OldApp:TApplication;

{$R *.RES}

//    
function GetModuleInfo:TModuleInfo;stdcall;
var
  Buffer:array [byte] of char;
begin
  with Result do begin
    Name:='  ';
    Kind:=mkGraph;
    if GetModuleFileName(hInstance,@Buffer,SizeOf(Buffer)-1)>0 then
      Path:=ExtractFilePath(StrPas(Buffer));
  end;
end;

// 
procedure Initialize;stdcall;
begin
  //   Application
  OldApp:=Application;
  fmGraphMain:=nil;
end;

// 
procedure Run;stdcall;
begin
  //   
  if fmGraphMain=nil then
    fmGraphMain:=TfmGraphMain.Create(Application);
end;

// 
procedure Terminate;stdcall;
begin
  //  
  fmGraphMain.Free;
  fmGraphMain:=nil;
  //   TApplication
  Application:=OldApp;
end;

//  
procedure SetData(Kind:TDataKind;const Buffer;Size:Integer);stdcall;
begin
  case Kind of
    //  TApplication
    dkApplication:if Size=SizeOf(TApplication) then
      Application:=TApplication(Buffer);
    //     
    dkInputData:if fmGraphMain<>nil then begin
      fmGraphMain.SetData(Buffer,Size);
    end;
  end;
end;

exports
  GetModuleInfo index Integer(piGetModuleInfo) name 'GetModuleInfo',
  Initialize index Integer(piInitialize) name 'Initialize',
  Run index Integer(piRun) name 'Run',
  Terminate index Integer(piTerminate) name 'Terminate',
  SetData index Integer(piSetData) name 'SetData';

begin
end.
