unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, SharedTypes, Modules, ExtCtrls;

type
  TfmMain = class(TForm)
    edPath: TEdit;
    lbPath: TLabel;
    btStart: TButton;
    Events: TTimer;
    procedure btStartClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure EventsTimer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fmMain: TfmMain;
  ModulesList:array of TModule;

implementation

{$R *.DFM}
// c 
procedure TfmMain.FormCreate(Sender: TObject);
begin
  Randomize;
end;
//   
procedure TfmMain.btStartClick(Sender: TObject);
  //    
  procedure AppendModulesList(FileName:String);
  var
    Module:TModule;
    IsValid:Boolean;
  begin
    //   
    Module:=TModule.Create(FileName,IsValid);
    //   
    if not IsValid then
      // 
      Module.Free
    else begin
      // 
      SetLength(ModulesList,Length(ModulesList)+1);
      ModulesList[Length(ModulesList)-1]:=Module;
    end;
  end;

var
  sr:TSearchRec;
  i:Integer;
begin
  //   
  SetLength(ModulesList,0);
  //   *.dll
  if FindFirst(edPath.Text+'*.dll',faAnyFile and not faDirectory,sr)=0 then begin
    AppendModulesList(edPath.Text+sr.Name);
    while FindNext(sr)=0 do
      AppendModulesList(edPath.Text+sr.Name);
  end;
  //   
  if Length(ModulesList)>0 then begin
    for i:=0 to Length(ModulesList)-1 do begin
      // 
      ModulesList[i].Initialize;
      //  Application
      ModulesList[i].SetData(dkApplication,Application,SizeOf(Application));
      //  
      ModulesList[i].Run;
    end;
    //  
    Events.Enabled:=True;
  end;
end;
//   
procedure TfmMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var
  i:Integer;
begin
  //  
  if Length(ModulesList)>0 then
    for i:=0 to Length(ModulesList)-1 do begin
      // 
      ModulesList[i].Terminate;
      // 
      ModulesList[i].Free;
    end;
end;

procedure TfmMain.EventsTimer(Sender: TObject);
var
  Values:TValues;
  i:Integer;
begin
  //   
  Values[0]:=Random($ffff);
  Values[1]:=Random($ffff);
  //    
  if Length(ModulesList)>0 then
    for i:=0 to Length(ModulesList)-1 do begin
      ModulesList[i].SetData(dkInputData,Values,SizeOf(Values));
    end;
end;

end.
